<?php
/*
 * E-Marketplace Services Plugin for Zen Cart
 * 
 * Version 1.0
 *
 * Copyright (c) 2019 TriStone Cloud Inc.
 *
 *
 * Released under the GNU General Public License v2
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; under version 2 of the License
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
 */
?>
<?php
require('includes/application_top.php');

header('Content-Type: application/json');

$VERSION = "1.0.0";
/**
 * Authenticate the connection.
 */
function checkAccess($db = null)
{
    $user = $_GET['user'];
    $pass = $_GET['pass'];
    // Login with API Key

    if (isset($user) && isset($pass) && strlen($user) > 0 && strlen($pass) > 0) {


        $sql = "SELECT admin_id, admin_pass FROM " . TABLE_ADMIN . " WHERE admin_name = '" . $user . "'";
        $result = $db->Execute($sql);
        //validate the password with the zencart encrypted password
        if (!zen_validate_password($pass, $result->fields['admin_pass'])) {
            header('HTTP/1.0 401 Unauthorized');
            $out = array('message' => 'Unauthorized1');
            echo json_encode($out);
            exit;
        }
    } else {
        header('HTTP/1.0 401 Unauthorized');
        $out = array('message' => 'Unauthorized2');
        echo json_encode($out);
        exit;
    }
}

/**
 * List orders
 */
function getOrders($db = null)
{
    $start = timestampToDate((!isset($_GET['start_modify_date']) ? time() : $_GET['start_modify_date']));
    $end = timestampToDate((!isset($_GET['end_modify_date']) ? time() : $_GET['end_modify_date']));

    //get order from database
    $sql = "SELECT * FROM " . TABLE_ORDERS .
        " WHERE orders_id >'0' AND IFNULL(last_modified, date_purchased) BETWEEN '" .
        $start . "' AND '" . $end . "';";
    $result = $db->Execute($sql);


    $orders = array();
    if ($result->fields['orders_id']) {

        while (!$result->EOF) {
            $order = array();

            // order products
            $products_query = "SELECT * FROM " . TABLE_ORDERS_PRODUCTS . " WHERE orders_id = '" . $result->fields['orders_id'] . "'";
            $products_result = $db->Execute($products_query);


            $orders_id = $result->fields['orders_id'];
            $shipping_query = "SELECT * FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '$orders_id' and class = 'ot_shipping'";
            $shipping_result = $db->Execute($shipping_query);

            $orders_status = $db->Execute("select orders_status_id, orders_status_name
	                                 from " . TABLE_ORDERS_STATUS . "
	                                 where language_id = '1' and orders_status_id = '" . $result->fields['orders_status'] . "'");

            if ($orders_status->fields['orders_status_name']) {
                $order_status = $orders_status->fields['orders_status_name'];
                $order_status_id = $orders_status->fields['orders_status_id'];
            } else {
                $order_status = 'unknown';
                $order_status_id = '';
            }

            if ($order_status_id) {

                $orders_history_comments = $db->Execute("select comments
	                                      from " . TABLE_ORDERS_STATUS_HISTORY . "
	                                      where orders_id = '" . zen_db_input($result->fields['orders_id']) . "' and (comments is not null or comments != '')
	                                    order by date_added LIMIT 1");

                $shipping_comments = $orders_history_comments->fields['comments'];
            } else {
                $shipping_comments = '';
            }


            //order details
            $order["orderId"] = $result->fields['orders_id'];
            $order["orderDate"] =  $result->fields['date_purchased'];
            $order["status"] =  $order_status;
            $order["lastModified"] =  $result->fields['last_modified'];
            $order["paymentMethod"] =  $result->fields['payment_method'];
            $order["shippingMethod"] =  $result->fields['shipping_method'];
            $order["currency"] =  $result->fields['currency'];
            $order["totalAmount"] =  0.0 + $result->fields['order_total'];
            $order["taxAmount"] =  0.0 + $result->fields['order_tax'];
            $order["shippingAmount"] =  0.0 + $shipping_result->fields['value'];
            $order["comments"] =   $shipping_comments;
            $order["customerId"] =  $result->fields['customers_id'];
            $order["email"] =  $result->fields['customers_email_address'];
            $order["phone"] =  $result->fields['customers_telephone'];




            //shipping details


            $shippingAddress = array();

            $shippingAddress["name"] = $result->fields['delivery_name'];
            $shippingAddress["company"] = $result->fields['delivery_company'];
            $shippingAddress["addr1"] =  $result->fields['delivery_street_address'];
            $shippingAddress["addr2"] = $result->fields['delivery_suburb'];
            $shippingAddress["city"] =  $result->fields['delivery_city'];
            $shippingAddress["postalCode"] = $result->fields['delivery_postcode'];
            $shippingAddress["state"] = $result->fields['delivery_state'];
            $shippingAddress["country"] = $result->fields['delivery_country'];

            $order["shippingAddress"] = $shippingAddress;


            $orderItems = array();
            while (!$products_result->EOF) {

                $image_query = "SELECT products_image, products_weight FROM " . TABLE_PRODUCTS . " WHERE products_id = '" . $products_result->fields['products_id'] . "'";
                $image_result = $db->Execute($image_query);

                $item = array();
                $item["productID"] = $products_result->fields['products_id'];
                $item["sku"] = $products_result->fields['products_model'];
                $item["name"] = $products_result->fields['products_name'];
                $item["image"] = HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_IMAGES . $image_result->fields['products_image'];
                $item["weight"] = $image_result->fields['products_weight'];
                $item["unitPrice"] = round($products_result->fields['final_price'], 2);
                $item["quantity"] = $products_result->fields['products_quantity'];

                $options_query = "SELECT orders_products_attributes_id, products_options, products_options_values  FROM " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES .
                    " WHERE orders_id = '" . $result->fields['orders_id'] . "' and orders_products_id = '" . $products_result->fields['orders_products_id'] . "'";
                $options_result = $db->Execute($options_query);

                $options = array();
                while (!$options_result->EOF) {
                    $option = array(
                        "name" => $options_result->fields['products_options'],
                        "value" => $options_result->fields['products_options_values']
                    );
                    array_push($options, $option);
                    $options_result->MoveNext();
                }
                $item["options"] = $options;

                array_push($orderItems, $item);
                $products_result->MoveNext();
            }
            $order["products"] = $orderItems;
            array_push($orders, $order);
            $result->MoveNext();
        }
    }
    $out = array("orders" => $orders);
    echo json_encode($out);
}

function timestampToDate($input)
{
    return date("Y-m-d H:i:s", $input);
}

/**
 * Update order comments
 */
function uploadTracking($db = null, $data)
{
    if ($data['orderId'] && $data['comment']) {
        $customer_notified = '1';
        $sql = "SELECT orders_id FROM " . TABLE_ORDERS . " WHERE orders_id = '" . $data['orderId'] . "'";
        $result = $db->Execute($sql);

        if (isset($result) && $result->fields['orders_id']) {
            $status = 4;

            $status_updated = zen_update_orders_history(
                $data['orderId'],
                $data['comment'],
                "E-Marketplace Services",
                $status,
                $customer_notified,
                true
            );
            if ($status_updated > 0) {
                $out = array('message' => 'Order status update was successful.', "status" => 0);
                echo json_encode($out);
            } else {
                $out = array('message' => 'Failed to update order status.', "status" => 1);
                echo json_encode($out);
            }
        } else {
            $out = array('message' => 'orderId ' . $data['orderId'] . ' does not exist.', "status" => 1);
            echo json_encode($out);
        }
    } else {
        $out = array('message' => 'orderId and comment must be specified', "status" => 1);
        echo json_encode($out);
    }
}

/**
 * Update product quantity
 */
function updateProductQuantity($db = null, $data)
{
    $products = $data["products"];
    $updated = array();
    $notUpdated = array();
    foreach ($products as $product) {
        $productId = $product["productId"];
        $quantity = 0.0 + $product["quantity"];
        $sql = "SELECT products_id FROM " . TABLE_PRODUCTS_DESCRIPTION . " WHERE products_id = '" . $productId . "'";
        $result = $db->Execute($sql);

        if (isset($result) && $result->fields['products_id']) {

            $sql_data_array = array(
                'products_quantity' => $quantity
            );
            zen_db_perform(
                TABLE_PRODUCTS,
                $sql_data_array,
                'update',
                "products_id = " . (int) $productId
            );
            array_push($updated, $productId);
        } else {
            array_push($notUpdated, $productId);
        }
    }
    $status = 1;
    if (empty($notUpdated)) {
        $status = 0;
    }
    $out = array('message' => 'Updated: ' . implode(", ", $updated) . "; Not updated: " . implode(", ", $notUpdated), "status" => $status);
    echo json_encode($out);
}

checkAccess($db);
if (isset($_REQUEST['debug'])) {
    error_reporting(E_ALL);
    ini_set('display_errors', 'On');
}
if (isset($_REQUEST['task'])) {
    if ($_REQUEST['task'] == 'orders') {
        getOrders($db);
    } else if ($_REQUEST['task'] == 'version') {
        $out = array('version' => $VERSION);
        echo json_encode($out);
    } else {
        // check POST
        $json = file_get_contents('php://input');
        $data = json_decode($json, true);
        if ($_REQUEST['task'] == 'uploadTracking') {
            uploadTracking($db, $data);
        } else if ($_REQUEST['task'] == 'updateProducts') {
            updateProductQuantity($db, $data);
        }
    }
}

?>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>